/*****************************************************************************
	FILE:	benchmark.2.c
	
	DESCRIPTION:
		Benchmark routines implementation in A.S.R.
				
	VERSION:
		.1 - 19990614 - system clock based
		.2 - 20021015 - process times based
******************************************************************************/

#include <sys/times.h>
#include <unistd.h>

struct tms tmsBegin;
struct tms tmsEnd;

/*+ benchmark_start
PROTOTYPE:
	void benchmark_start(void);
	
DESCRIPTION:
	Runs a time counter for delay measurement.
	
PARAMETERS:
	none
	
RETURNS:
	nothing
-*/

void benchmark_start(void){	
	times(&tmsBegin);
} /* benchmark_start */

/*+ benchmark_stop
PROTOTYPE:
	long benchmark_stop(void);
	
DESCRIPTION:
	Stops the time counter for delay measurement.
	
PARAMETERS:
	none
	
RETURNS:
	number of milliseconds between start and stop counter calls.
-*/

long benchmark_stop(void){
	times(&tmsEnd);
	
	return ((tmsEnd.tms_utime - tmsBegin.tms_utime) +
		(tmsEnd.tms_stime - tmsBegin.tms_stime)) * 10;
} /* benchmark_stop */

/* end of file - benchmark.2.c */
